
-- Hello there curious viewer. Please bear in mind this code is COMPLETELY FULL of 
-- spaghetti bullshit. I wish you the best of luck looking at this rancid mix of old and new code
--																- Jon

-- Main function for Trip, ie. PlayerThink stuff
local function TripMain(p)
	
	if not( trip.IsValid(p.mo, true) ) return end

	-- Initialization stuff. Create a table for variables, check if we are alive and such
	if p.mo.skin ~= "trip"
		if p.TRP
			-- Seems like we were super before switching characters. Let's fix some stuff.
			if p.TRP.superReturn
				p.mo.flags = $ & ~MF_NOGRAVITY
				p.TRP.superFlight = nil
				if p.TRP.truesize
					p.mo.destscale = p.TRP.truesize
					p.TRP.truesize = nil
				end
			end
			p.TRP = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			p.mo.spritexoffset = 0
			p.mo.extravalue1 = 0
			if CBW_Battle
				p.actionstate = 0
				p.actiontime = 0
				p.doaction = 0
			end
			-- Reset our gravity on switch
			if p.mo.trip_ceilingstick
				p.mo.state = S_PLAY_FALL
				p.mo.trip_ceilingstick = nil
				p.mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
				p.mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
			end
			-- We may be in a weird state, so let's fix that
			if (p.mo.state == S_PLAY_TRIPTRIP or p.mo.state == S_PLAY_TWAIT1 or p.mo.state == S_PLAY_TWAIT2
			or p.mo.state == S_PLAY_TRIPFBALL1 or  p.mo.state == S_PLAY_TRIPFBALL2 or p.mo.state == S_PLAY_TRIPFBALL3)
				p.mo.state = S_PLAY_STND
			end
			if trip.CUSTTEAMCOLOR and gametyperules & GTR_TEAMS
				if p.mo.color == SKINCOLOR_CORNFLOWER then p.mo.color = SKINCOLOR_BLUE
				elseif p.mo.color == SKINCOLOR_KETCHUP then p.mo.color = SKINCOLOR_RED end
			end
		end
		
		return 
	end
	
	if p.playerstate ~= PST_LIVE return end

	-- Let's initialize our per-played "trip table" for things each person should have
	if not p.TRP
		p.TRP = {}
		p.TRP.wallSpeed = 0
		p.TRP.wallStrafe = 0
		p.TRP.jumpHold = false
		p.TRP.tackled = false
		p.TRP.lastState = S_PLAY_STND
		p.TRP.lastMomz = 0
		p.TRP.lastFrame = A
		p.TRP.climbCooldown = 0
		p.TRP.flameGas = 0
		p.TRP.flameTime = 0
		p.TRP.bounceCharge = 0
		p.TRP.bounced = false
		p.TRP.bounceLock = false
		p.TRP.bounceLockPanic = trip.BOUNCELOCKPANIC
		p.TRP.preventSpikeHold = false
		p.TRP.shieldease = 0
		p.TRP.spikemode = false
		p.TRP.wallreverse = false
		p.TRP.wallbuffer = 0
		p.TRP.squashpanic = 0
		p.TRP.superreturntimer = 0
		if p.mo.state == S_PLAY_WAIT then p.mo.state = S_PLAY_STND end
		p.actiontime = 0
	end

	-- Let's handle our super transform input here so it works on both .13 and .14
	local superbutton = SUBVERSION < 14 and BT_SPIN or BT_SHIELD
	if (p.cmd.buttons & superbutton) and (SUBVERSION >= 14 or not P_IsObjectOnGround(p.mo))
	and (not p.exiting) and (not P_PlayerInPain(p)) and (not p.TRP.superReturn) and (not p.TRP.superreturntimer)
		if not (p.solchar and p.solchar.istransformed) then trip.TrySuperTransform(p, superbutton) end
	end
	
	-- We went super! Forget everything below and move on to Trip_Super.lua
	if p.powers[pw_super]
		trip.SuperThinker(p)
		return
	elseif p.TRP.superReturn
	-- Going back to normal after transforming. Let's get our default stats back
		p.charflags = $ & ~SF_NOJUMPSPIN
		p.TRP.superreturntimer = TICRATE*2
		if p.TRP.truesize
			p.mo.destscale = p.TRP.truesize
			p.mo.radius = skins["trip"].radius
			p.mo.height = skins["trip"].height
			p.TRP.truesize = nil
			p.charflags = $ & ~SF_SUPER
		end
		trip.ReturnFromSuper(p)
	end

	if p.TRP.superreturntimer then p.TRP.superreturntimer = $-1 end
	
	-- Remove any straggler followmobjs from becoming super
	if p.followmobj and p.followmobj.valid
		p.followitem = MT_NULL
		p.followmobj = nil
	end
	
	if p.TRP.flameTime
		p.TRP.flameTime = $-1
		if not p.TRP.flameTime 
			S_StopSoundByID(p.mo, sfx_trftst)
			S_StopSoundByID(p.mo, sfx_trftlo)
		end
	end
	
	-- The funny
	trip.EasterEggsT(p)
	
	-- Reset our charability when not climbing
	-- Rush: or when we reach exhaust
	if not p.climbing 
		p.charability = CA_NONE
		p.TRP.wallStrafe = 0
		if p.TRP.wallRoll ~= 0
			p.TRP.wallRoll = 0
			p.mo.rollangle = 0
		end
	else
		-- We are climbing a wall! Let's mess with our momentum over at Trip_WallMovement
		trip.WallClimbMovement(p)
	end
	
	-- Spike state stuff
	if p.mo.state == S_PLAY_TRSPIKE or p.mo.state == S_PLAY_TNROLL2
		if not (leveltime%2) 
			local boo = P_SpawnGhostMobj(p.mo)
			boo.tics = 4
			boo.scale = p.mo.scale -- y tho
		end
		
		if p.mo.state == S_PLAY_TRSPIKE
			local too = (twodlevel) or (p.mo.flags2 & MF2_TWOD)
			if (p.cmd.forwardmove > 0 or too or p.TOMNICLIMB) then trip.DoWallClimb(p) end
			-- End the spike state if not holding jump
			if (not (p.cmd.buttons & BT_JUMP)) and (not p.TRP.bounceLock)
				p.mo.state = S_PLAY_JUMP
				trip.WallReset(p)
			end
		end
	end

	-- We were charging our fireball and blinking. Reset that blinking when we're done.
	if p.mo.colorized 
	and (p.TRP.lastState == S_PLAY_TRIPFBALL1 or p.TRP.lastState == S_PLAY_TRIPFBALL2 or p.TRP.lastState == S_PLAY_TRIPFBALL3
	or p.TRP.lastState == S_PLAY_TRIPFBALL1_AIR or p.TRP.lastState == S_PLAY_TRIPFBALL2_AIR)
		p.mo.colorized = false
	end

	-- Also reset our scale after trip's "breathe in" phase of the fireball
	if (p.TRP.lastState == S_PLAY_TRIPFBALL1 or p.TRP.lastState == S_PLAY_TRIPFBALL1_AIR)
	and p.mo.state ~= S_PLAY_TRIPFBALL1 and p.mo.state ~= S_PLAY_TRIPFBALL1_AIR
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
	end

	-- SPAGHETT
	if p.mo.state == S_PLAY_TRIPFBALL1 and not P_IsObjectOnGround(p.mo) then p.mo.state = S_PLAY_TRIPFBALL1_AIR end
	if p.mo.state == S_PLAY_TRIPFBALL2 and not P_IsObjectOnGround(p.mo) then p.mo.state = S_PLAY_TRIPFBALL2_AIR end
	if p.mo.state == S_PLAY_TRIPFBALL1_AIR and P_IsObjectOnGround(p.mo) then p.mo.state = S_PLAY_TRIPFBALL1 end
	if p.mo.state == S_PLAY_TRIPFBALL2_AIR and P_IsObjectOnGround(p.mo) then p.mo.state = S_PLAY_TRIPFBALL2 end

	-- We let go off a wall last frame, so reset our wall detection
	if (p.TRP.lastState == S_PLAY_CLING or p.TRP.lastState == S_PLAY_CLIMB)
	and (p.mo.state ~= S_PLAY_CLING and p.mo.state ~= S_PLAY_CLIMB)
		trip.WallReset(p)
		p.TRP.wallbuffer = 3
	end
	if p.TRP.wallbuffer then trip.WallReset(p) p.TRP.wallbuffer = $-1 end
	
	-- We were being carried by something. Give trip a few tics before she can latch onto something while spinning
	if p.powers[pw_carry]
		p.TRP.climbCooldown = 5
		p.climbing = 0 -- because zoom tubes are the devil
	end
	if p.TRP.climbCooldown then p.TRP.climbCooldown = $ - 1 end

	-- Launching off walls then pressing jump right after is a bit iffy, so let's give it a delay
	if p.TRP.thokDelay 
		p.TRP.thokDelay = $-1
		if not p.TRP.thokDelay then p.pflags = $ & ~PF_THOKKED end
	end

	-- Reset our squash and stretch in case something goes wrong
	if p.TRP.squashpanic
		p.TRP.squashpanic = $-1
		if not p.TRP.squashpanic
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end
	end

	-- Mess with our momz the game after launching ourselves off a wall
	if p.TRP.doLaunch
		S_StartSound(p.mo, sfx_zoom)
		P_SetObjectMomZ(p.mo, p.TRP.launchMom - (p.TRP.launchMom/5))
		S_StopSoundByID(p.mo, sfx_jump)
		p.TRP.doLaunch = nil
		p.TRP.launchMom = nil
	end

	-- Rev up our wall climb through the spindash's charge
	if p.dashspeed
		p.TRP.wallTime = p.dashspeed
	end
	if p.TRP.wallTime
		p.TRP.wallTime = $-FRACUNIT
		if ((p.cmd.buttons & BT_JUMP) and p.mo.state ~= S_PLAY_TNROLL2 and p.mo.state ~= S_PLAY_SPINDASH)
		or p.powers[pw_carry] 
			p.TRP.wallTime = 0 
		end
		if p.TRP.wallTime < 0 then p.TRP.wallTime = 0 end
	end

	-- Battle mode is on! Find a target!
	if CBW_Battle 
		trip.BattleTargetFinder(p)
	end

	-- Things to be done when we go idle
	trip.IdleCheck(p)

	-- Make sure our "bounce lock" when pressing spin during a rev is reset properly
	if p.TRP.bounceLock
		p.TRP.bounceLockPanic = $-1
		local force = FixedMul(P_GetMobjGravity(p.mo), trip.BOUNCESTOPFORCE)
		local fracs = trip.BOUNCEMAXMOMZ*FRACUNIT

		p.mo.momz = trip.Clamp($ + force, -fracs, fracs)
		local t = abs(p.mo.momz)/trip.BOUNCEMAXMOMZ
		p.mo.spritexscale = ease.outcubic(t, FRACUNIT, FRACUNIT*8/10)
		p.mo.spriteyscale = ease.outcubic(t, FRACUNIT, FRACUNIT*15/10)

		if (p.mo.state ~= S_PLAY_TRSPIKE or P_IsObjectOnGround(p.mo))
		or p.TRP.bounceLockPanic <= 0
		or P_IsObjectInGoop(p.mo)
			p.TRP.bounceLock = false
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end
	end
	
	-- We'll use the usually super-exclusive flame gas variable for some fiery vfx
	if p.TRP.flameGas and not (leveltime%3)
		p.TRP.flameGas = $-1
		for i=1, 4 do
			local rad = p.mo.radius/FRACUNIT
			local pos = {P_RandomRange(-rad, rad)*FRACUNIT, P_RandomRange(-rad, rad)*FRACUNIT}
			local hei = p.mo.height/FRACUNIT
			hei = P_RandomRange(0, $)*FRACUNIT
			local flam = P_SpawnMobjFromMobj(p.mo, pos[1], pos[2], hei, MT_FLAMEPARTICLE)
			flam.scale = FRACUNIT*3/2
			flam.destscale = 1
			flam.scalespeed = FRACUNIT/15
			flam.fuse = 15
			flam.frame = $|FF_TRANS20|FF_FULLBRIGHT
		end
	end
	
	-- Changes being brought into the next tic
	p.TRP.lastState = p.mo.state
	p.TRP.lastMomz = p.mo.momz
	p.TRP.lastFrame = (p.mo.frame & FF_FRAMEMASK)

end


-- Double jump ability
local function TripJump(p)
	if not trip.IsValid(p.mo) return end

	-- nuh uh
	if p.gotflag
	or p.gotcrystal 
	or p.exiting
		return
	end
	if p.powers[pw_super]
		trip.SuperAbilityThinker(p)
		return
	end

	-- Double jump!
	if not (p.pflags & PF_THOKKED)
		trip.WallReset(p)
		if (p.exhaustmeter ~= nil and p.exhaustmeter == 0) then return end
		local forceChange = 0
		if (p.mo.eflags & MFE_UNDERWATER) then forceChange = (trip.DJUFORCE/10) * -4 end -- d. jump reduced to 60% force underwater
		local force = (p.solchar and p.solchar.istransformed) and trip.SOLJFORCE or trip.DJUFORCE
		P_SetObjectMomZ(p.mo, force + forceChange )
		p.pflags = $ | PF_THOKKED
		if p.mo.state ~= S_PLAY_TRSPIKE
			S_StartSoundAtVolume(p.mo, sfx_tcurl, 200)
			p.mo.state = S_PLAY_TRSPIKE
			p.TRP.bounceCharge = 0
		end
	end
end


-- Enable spikes when holding jump after D. jump
local function TripSpikes(p)
	if not trip.IsValid(p.mo) return end
	
	if p.mo.state == S_PLAY_TNROLL2 
	or p.exiting
	or (p.mo.GSgrind and p.mo.GSgrind.JumpRamp)
		return
	end
	
	if p.mo.state == S_PLAY_TRSPIKE
		-- Keep charging our bounce speed and force while holding jump while revved
		if (not P_IsObjectOnGround(p.mo)) and not (p.climbing) 
			p.TRP.bounceCharge = min($ + (p.TRP.bounceLock and 2 or 1) , trip.BOUNCEMAXTICS)
		end
		return
	end
	if p.mo.state == S_PLAY_TRIPFBALL2 or p.mo.state == S_PLAY_TRIPFBALL1
	or p.mo.state == S_PLAY_TRIPFBALL2_AIR or p.mo.state == S_PLAY_TRIPFBALL1_AIR
		return true 
	end
	if p.powers[pw_super]
		if not p.TRP.superFlight and not p.TRP.jumpHold and not P_IsObjectOnGround(p.mo) and not p.powers[pw_carry]
			trip.SuperAbilityThinker(p)
			return
		end
	end
	
	-- Launch ourselves off of walls
	if p.climbing and not (p.lastbuttons & BT_JUMP)
		p.TRP.thokDelay = 3
		p.TRP.doLaunch = true
		p.TRP.launchMom = p.TRP.wallSpeed
		p.mo.state = S_PLAY_JUMP
		trip.WallReset(p)
	end
	
	if p.TRP.preventSpikeHold return end
	
	-- Rev up our spikes for climbing
	if (p.pflags & PF_THOKKED) and not P_IsObjectOnGround(p.mo) and (p.panim == PA_JUMP or p.panim == PA_ROLL)
	and not p.TRP.bitchassrevupbullshit
	and p.mo.state ~= S_PLAY_TRSPIKE
		trip.WallReset(p)
		p.mo.state = S_PLAY_TRSPIKE
		S_StartSoundAtVolume(p.mo, sfx_tcurl, 200)
		p.TRP.bounceCharge = 0
	end
end


-- We hit an enemy in our spike form. Return from the rev form and gain your jump back
local function TripSpikeBoost(mo, pmo)
	if not pmo or not mo return end
	if not pmo.valid or not mo.valid return end
	if not trip.IsValid(pmo, false) return end

	if pmo.state == S_PLAY_TRSPIKE then pmo.state = S_PLAY_JUMP end
	if not P_IsObjectOnGround(pmo)
		pmo.player.pflags = $ & ~PF_SPINNING
	end
	pmo.player.pflags = $ & ~PF_THOKKED
	pmo.player.TRP.bounced = false
	if pmo.player.TRP.bounceLock
		P_SetObjectMomZ(pmo, max(10*FRACUNIT, FixedDiv(pmo.momz, FRACUNIT*2)))
		pmo.player.TRP.bounceLock = false
		pmo.spritexscale = FRACUNIT
		pmo.spriteyscale = FRACUNIT
	end
	trip.WallReset(pmo.player)
end

-- Something hit us!
local function TripDamageReset(pmo, mo)
	if not pmo.valid return end
	if not trip.IsValid(pmo) return end
	local p = pmo.player

	pmo.spritexoffset = 0
	pmo.extravalue1 = 0
	pmo.spritexscale = FRACUNIT
	pmo.spriteyscale = FRACUNIT
	-- Prevent trip from tripping again in case she got hurt while in her stumble state
	if p and p.TRP
		p.TRP.uhOh = nil
	end
	-- Reset our gravity preemtively to prevent spilled ring shenanigans
	if pmo.trip_ceilingstick
		pmo.trip_ceilingstick = nil
		pmo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
		pmo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
	end
end

-- Same as the enemies' function above
local function MonitorSpikeBoost(mo, pmo, source, dmg)
	if not pmo or not mo return end
	if not pmo.valid or not mo.valid return end
	if not trip.IsValid(pmo, false) return end
	if not (mo.flags & MF_MONITOR) return end

	if pmo.state == S_PLAY_TRSPIKE then pmo.state = S_PLAY_JUMP end
	pmo.player.pflags = $ & ~PF_THOKKED
	if pmo.player.TRP.bounceLock
		P_SetObjectMomZ(pmo, max(10*FRACUNIT, FixedDiv(pmo.momz, FRACUNIT*2)))
		pmo.player.TRP.bounceLock = false
		pmo.spritexscale = FRACUNIT
		pmo.spriteyscale = FRACUNIT
	end
	trip.WallReset(pmo.player)
end

addHook("MobjDeath", MonitorSpikeBoost)

-- For lots of stuff to be done before our PlayerThink execution
local function TPreThink()

	-- OLDC name changer thingy
	if OLDC and OLDC.SkinFullNames
		if not OLDC.SkinFullNames["trip"] then OLDC.SetSkinFullName("trip", "Trip the Sungazer") end
	end

	for p in players.iterate
		if not trip.IsValid(p.mo) continue end
		
		-- Super stuff. Execute nothing after this point if super.
		if p.powers[pw_super]
			trip.SuperPreThinker(p)
			continue 
		end

		if p.mo.state == S_PLAY_TRSPIKE
			p.charflags = $ & ~SF_RUNONWATER
		end

		if (p.mo.eflags & MFE_SPRUNG) and p.TRP.bounceLock
			p.TRP.bounced = true
			p.TRP.bounceLock = false
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			p.TRP.preventSpikeHold = true
		end

		if p.TRP.spinHold and p.climbing
			p.tripSpinFix = (p.cmd.buttons & BT_SPIN) -- this is pretty silly
			p.cmd.buttons = $ & ~BT_SPIN
		end

		if p.TRP.preventSpikeHold and not (p.lastbuttons & BT_JUMP) then p.TRP.preventSpikeHold = false end

		if p.climbing
			p.TRP.sidemove = trip.Clamp(p.cmd.sidemove, -1, 1)
			if not((twodlevel) or (p.mo.flags2 & MF2_TWOD)) then p.cmd.sidemove = 0 end
			p.TRP.preventSpikeHold = true
			p.pflags = $ & ~PF_SPINNING
			if (P_MobjFlip(p.mo) * p.mo.momz < 5*FRACUNIT)
			and p.mo.state == S_PLAY_CLIMB
				p.mo.tics = 10
				local frame = ((leveltime%20)/5)+1
				p.mo.frame = ($ & ~FF_FRAMEMASK) | trip.inverseRoll[frame]
			end
			if p.mo.state == S_PLAY_CLING and abs(p.mo.momz) > 5*FRACUNIT
				local frame = ((leveltime%20)/5)+1
				p.mo.frame = ($ & ~FF_FRAMEMASK) | trip.fakeRoll[frame]
			end
		end

		-- We should be able to climb a wall after spindashing, so let's check for that
		if p.TRP.wallTime and p.mo.state == S_PLAY_TNROLL2 and not p.powers[pw_nocontrol] 
		and not p.TRP.climbCooldown and p.cmd.forwardmove >= 0
			trip.DoWallClimb(p)
			if p.climbing 
				if P_MobjFlip(p.mo) > 0
					p.mo.z = $ + FRACUNIT*3
				else
					p.mo.z = $ - p.mo.height
				end
			end
		end
		
		-- Sol emerald form handling. Become Terra Trip using the sol emeralds!
		if p.solchar
			if (p.SolTransforming) and (p.cmd.buttons & BT_SPIN) and not (p.solchar.spindown) and All7Emeralds(emeralds)
				p.charflags = $ & ~SF_NOSUPERSPRITES
				continue
			end
			-- ???????
			if p.mo.state == S_PLAY_SUPER_TRANS6 and p.mo.tics >= 14
				if p.mo.tics == 17 then p.mo.frame = ($ & ~FF_FRAMEMASK)|F end
				if p.mo.tics == 14 then p.mo.frame = ($ & ~FF_FRAMEMASK)|G end
			end
			-- We're entering our Terra Trip form. Ignore our super sprites.
			if (p.solchar.istransformed and not p.CancelSolTransform)
			--or (p.SolTransforming and not All7Emeralds(emeralds))
				p.charflags = $|SF_NOSUPERSPRITES
			end
		end

	end
end

-- PostThink stuff, like button tap checks
local function TPostThink()
	for p in players.iterate
		
		-- PostThink death team color handler for trip
		if p.mo and p.mo.valid and p.mo.skin == "trip" and p.playerstate == PST_DEAD
		and trip.CUSTTEAMCOLOR and gametyperules & GTR_TEAMS
			if p.mo.color == SKINCOLOR_BLUE then p.mo.color = SKINCOLOR_CORNFLOWER
			elseif p.mo.color == SKINCOLOR_RED then p.mo.color = SKINCOLOR_KETCHUP end
		end

		-- Regular PostThink stuff starts here
		if not trip.IsValid(p.mo) continue end
		local mo = p.mo

		if p.powers[pw_super]
			if (p.panim == PA_ROLL) or mo.state == S_PLAY_TNROLL2 
			or (p.powers[pw_carry] == CR_ZOOMTUBE) or (p.powers[pw_carry] == CR_MACESPIN) 
				trip.MaintainLightOrb(p)
			end
			-- what the fuck srb2
			if mo.state == S_PLAY_STND and mo.momz == 0 and not P_IsObjectOnGround(mo)
			and not p.speed 
			and (P_MobjFlip(mo) == 1 and mo.ceilingz - mo.z == 48*FRACUNIT)
				mo.state = S_PLAY_FLOAT
				P_Thrust(mo, mo.angle, FRACUNIT/2)
			end

			if S_SoundPlaying(mo, sfx_jump) and (mo.state < S_PLAY_SUPER_TRANS1 or mo.state > S_PLAY_SUPER_TRANS6)
				S_StopSoundByID(mo, sfx_jump)
				S_StartSound(mo, sfx_stjmp)
			end

			local GS = mo.GSgrind
			if GS 
				if GS.grinding
					mo.frame = $ | FF_ADD | FF_TRANS10 | FF_FULLBRIGHT
					if not CBW_Battle
						local ghost = P_SpawnGhostMobj(p.mo)
						P_InstaThrust(ghost, FixedAngle(P_RandomRange(1, 360)*FRACUNIT), P_RandomRange(-2, 2)*FRACUNIT)
						ghost.momz = P_RandomRange(-2, 2)*FRACUNIT
						ghost.destscale = 1
						ghost.sprite2 = SPR2_ROLL|FF_SPR2SUPER
					end
					mo.sprite2 = SPR2_GRND|FF_SPR2SUPER
				elseif GS.JumpRamp
					mo.sprite2 = SPR2_PAIN|FF_SPR2SUPER
				end
			end

			if p.milnekick
				S_StartSound(mo, sfx_lose)
				P_RestoreMusic(p)
				p.milnekick = 0
				mo.state = S_PLAY_WALK
			end
		end

		-- 2006 skate support using rail grind sprites!
		if p.mo.skate and p.mo.skate.valid then p.mo.sprite2 = SPR2_TAL8 end
		
		p.TRP.jumpHold = (p.cmd.buttons & BT_JUMP)
		p.TRP.spinHold = (p.cmd.buttons & BT_SPIN)

		-- oh my god
		if p.TRP.wallreverse
			if ((twodlevel) or (mo.flags2 & MF2_TWOD))
				if ((not p.cmd.sidemove) or (p.cmd.buttons & BT_JUMP) or (p.cmd.buttons & BT_SPIN))
					if p.climbing then mo.momz = 0 end
					p.TRP.wallreverse = false
				end
			else
				if ((not p.cmd.forwardmove) or (p.cmd.buttons & BT_JUMP) or (p.cmd.buttons & BT_SPIN))
					p.TRP.wallreverse = false
				end
			end
		end
		
		if p.TRP.lastState == S_PLAY_CLIMB and P_IsObjectOnGround(mo)
		and p.TRP.wallreverse and p.cmd.forwardmove > 0
			p.TRP.wallreverse = false
			mo.angle = $+ANGLE_180
			p.drawangle = mo.angle
			local momentum = -p.TRP.lastMomz
			local modifier = FRACUNIT*4/5
			P_InstaThrust(mo, mo.angle, FixedMul(modifier, momentum))
		end

		if p.tripSpinFix then p.TRP.spinHold = true end
		if p.TRP.bitchassrevupbullshit and not (p.cmd.buttons & BT_JUMP) then p.TRP.bitchassrevupbullshit = nil end
		p.tripSpinFix = false
		
		if p.TRP.wallSpriteFix
			mo.state = S_PLAY_CLIMB
			mo.sprite2 = SPR2_CLMB
			p.TRP.wallSpriteFix = nil
		end

		if p.TRP.lastState == S_PLAY_TRIPFBALL3 and mo.state ~= S_PLAY_TRIPFBALL3 and not P_PlayerInPain(p)
			mo.state = P_IsObjectOnGround(p.mo) and S_PLAY_STND or S_PLAY_FALL
			if not P_IsObjectOnGround(p.mo) then p.pflags = $ & ~PF_JUMPED end
		end

		trip.EasterEggsPT(p)
		if (p.mo.sprite2 == SPR2_TAL1 or p.mo.sprite2 == SPR2_TAL0)
		and ((not p.mo.tracer) or (p.mo.tracer and p.mo.tracer.valid and p.mo.tracer.target ~= p.mo))
			p.mo.sprite2 = SPR2_STND
			p.mo.tics = trip.CUSTIDLETIME
			p.mo.tracer = nil
		end

		if not p.powers[pw_super]
			if p.mo.state == S_PLAY_TNROLL2 or p.mo.state == S_PLAY_TRSPIKE
				p.powers[pw_strong] = STR_BUST
			else
				p.powers[pw_strong] = STR_NONE
			end
		end
		
		-- Bounce-tackle off the ground when landing from a revved up state
		local battle = (CBW_Battle and p.mo.cusval == SH_ELEMENTAL)
		local sol = p.solchar and p.solchar.istransformed
		if p.TRP.lastState == S_PLAY_TRSPIKE and P_IsObjectOnGround(mo)
		and p.playerstate == PST_LIVE and ((p.cmd.buttons & BT_JUMP) or p.TRP.bounceLock)
		and (not p.TRP.spikemode) and (not battle)
			//Be careful with quicksand...
			local nonsense = 11
			if p.TRIPTRIPPINGBULLSHIT then nonsense = P_RandomRange(1,100) end
			if P_InQuicksand(mo) or nonsense < 11
				p.TRP.youFoolYouAbsoluteBuffoon = nil
				if nonsense > 10
					if mo.watertop > mo.z
						mo.z = mo.watertop + 2*FRACUNIT
						S_StartSound(mo, sfx_ghit)
						P_SpawnMobjFromMobj(mo, 0,0,0, MT_SPLISH)
					else
						mo.z = $-p.TRP.lastMomz
						S_StartSound(mo, sfx_s3kc8s)
						local addAngle = 0
						for i=1, 8 do
							local dust = P_SpawnMobjFromMobj(mo, 0, 0, 6*FRACUNIT, MT_SPINDUST)
							dust.frame = $ + FF_TRANS50
							dust.angle = mo.angle + addAngle
							addAngle = $ + FixedAngle( 45 * FRACUNIT )
							P_InstaThrust(dust, dust.angle, 6*FRACUNIT )
							dust.scale = FRACUNIT/2
						end
					end
				else
					mo.z = $+FRACUNIT*2
				end
				P_SetObjectMomZ(mo, 7*FRACUNIT)
				p.pflags = $ | PF_JUMPED | PF_THOKKED
				P_InstaThrust(mo, p.drawangle, 4*FRACUNIT)
				p.TRP.uhOh = true
				p.powers[pw_nocontrol] = TICRATE*2
				S_StartSound(mo, sfx_toops)
				mo.state = S_PLAY_PAIN
				mo.sprite2 = SPR2_LAND
				p.TRP.bounceCharge = 0
				p.TRP.bounced = false
				p.TRP.bounceLock = false
				mo.spritexscale = FRACUNIT
				mo.spriteyscale = FRACUNIT
				p.TRP.preventSpikeHold = true

			// We charged enough! Start the bounce!
			elseif not p.TRP.bounced
				-- Set some base parameters
				mo.state = S_PLAY_JUMP
				p.pflags = $|(PF_SPINNING|PF_JUMPED|PF_JUMPDOWN|PF_THOKKED)
				S_StartSound(mo, sfx_spin)
				S_StartSound(mo, sfx_shrpgo)
				local force = sol and {12, 8} or {6, 5}
				if p == consoleplayer then P_StartQuake(force[1]*FRACUNIT, force[2]) end
				-- Let's thrust ourselves using our charge up time as long as we're holding forward
				if p.cmd.forwardmove
					local speed = ease.linear((p.TRP.bounceCharge * FRACUNIT) / trip.BOUNCEMAXTICS, trip.BOUNCEMINSPD, trip.BOUNCEMAXSPD)
					if (mo.eflags & MFE_UNDERWATER) then speed = FixedDiv($, FRACUNIT*2) end
					local diagonal = 0
					if p.cmd.sidemove then diagonal = 1 end
					local adjustedSpeed = speed - (speed/3)*diagonal
					local finalSpeed = max(min(FixedHypot(mo.momx, mo.momy),trip.BOUNCEMAXSPD), adjustedSpeed)
					P_InstaThrust(mo, mo.angle, FixedMul(mo.scale, finalSpeed))
				end
				
				-- Then upwards as well
				mo.z = $ + FRACUNIT*5*P_MobjFlip(mo)
				local momz = abs(p.TRP.lastMomz or mo.momz)
				momz = FixedDiv($, p.TRP.bounceLock and FRACUNIT*3 or FRACUNIT*7/4)
				local min_height = trip.BOUNCEMINHEIG
				if (mo.eflags & MFE_UNDERWATER)
					momz = FixedDiv($, FRACUNIT*9/4)
					min_height = FixedDiv($, FRACUNIT*2)
				end
				P_SetObjectMomZ(mo, max(min_height, momz))
				p.TRP.bounced = true
				p.TRP.bounceLock = false
				mo.spritexscale = FRACUNIT
				mo.spriteyscale = FRACUNIT
				p.TRP.preventSpikeHold = true
				S_StartSound(p.mo, sol and sfx_s3k5f or sfx_cdfm32)
				
				-- And finally leave an impact shockwave where we landed
				local wave = P_SpawnMobjFromMobj(mo, 0,0,0, MT_UNKNOWN)
				wave.target = mo
				wave.sprite = SPR_TRSR
				wave.blendmode = AST_ADD
				wave.scale = 1
				if sol
					wave.destscale = FRACUNIT*8
					wave.scalespeed = FRACUNIT/3
					trip.DoSolShockwave(mo)
				else
					wave.destscale = FRACUNIT*4
					wave.scalespeed = FRACUNIT/5
				end
				wave.fuse = 9
				wave.frame = $|FF_TRANS10
				wave.flags2 = $|MF2_SPLAT
				wave.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				local rad = sol and 40 or 20
				for i=1, sol and 12 or 5 do
					local ang = P_RandomRange(0, 359)*ANG1
					local rocc = P_SpawnMobjFromMobj(mo, 
									 rad*cos(mo.angle + ang), 
									 rad*sin(mo.angle + ang), 
									 5*FRACUNIT,
					MT_FAKEROCK)
					if rocc
						rocc.state = S_ROCKCRUMBLEJ
						rocc.flags = $ & ~MF_PAIN
						rocc.scale = FRACUNIT/10
						rocc.destscale = FRACUNIT/2
						rocc.fuse = 16
						rocc.angle = mo.angle + ANGLE_90
						rocc.momz = 3*FRACUNIT * P_MobjFlip(mo)
						rocc.cusval = 1
						//P_SetObjectMomZ(rocc, P_RandomRange(6, 9)*FRACUNIT)
						P_InstaThrust(rocc, mo.angle + ang, 4*FRACUNIT)
					end
				end
				
				-- Special shield vfx!
				if p.mo.cusval and p.powers[pw_shield] and p.mo.cusval == SH_ELEMENTAL
					p.TRP.flameGas = TICRATE/2
					S_StartSound(p.mo, sfx_kc3b)
				end

			elseif p.speed > 7*FRACUNIT and p.TRP.bounced
			-- Not enough charge. Just roll forward.
				mo.state = S_PLAY_TNROLL2
				P_Thrust(mo, mo.angle, FRACUNIT*2 )																																		-- I'm keeping the bhop in :^)
				S_StartSound(mo, sfx_spin)
				p.pflags = $ | PF_SPINNING
				p.TRP.bounced = false
			end
		end
		
		-- Always roll when landing from a jump and holding SPIN
		if p.TRP.lastState == S_PLAY_JUMP and P_IsObjectOnGround(mo)
		and p.playerstate == PST_LIVE and (p.cmd.buttons & BT_SPIN)
		and p.speed >= 7*FRACUNIT
		and not p.TRP.bounceLock
			mo.state = S_PLAY_TNROLL2
			P_Thrust(mo, mo.angle, FRACUNIT*2 )																																		-- I'm keeping the bhop in :^)
			S_StartSound(mo, sfx_spin)
			p.pflags = $ | PF_SPINNING
			p.TRP.bounced = false
		end
		
		-- Ease our shield's scale over a few tics
		if trip.donutStates[p.mo.state]
			p.TRP.shieldease = min($+FRACUNIT/5, FRACUNIT)
		else
			p.TRP.shieldease = max($-FRACUNIT/5, 0)
		end
		p.shieldscale = ease.linear(p.TRP.shieldease, skins["trip"].shieldscale, FRACUNIT*13/10)

		-- Resetting our bounce when we ground ourselves. Also resets when climbing on a different script
		if p.TRP.bounced and P_IsObjectOnGround(mo) then p.TRP.bounced = false end
		if p.mo.cusval and P_IsObjectOnGround(p.mo) then p.mo.cusval = 0 end

		-- Custom colors for team game modes
		if trip.CUSTTEAMCOLOR and gametyperules & GTR_TEAMS
			if mo.color == SKINCOLOR_BLUE then mo.color = SKINCOLOR_CORNFLOWER
			elseif mo.color == SKINCOLOR_RED then mo.color = SKINCOLOR_KETCHUP end
		end

		-- We are no longer in a charged up state, so reset our shaking
		if (p.TRP.lastState == S_PLAY_TRIPFBALL2 or p.TRP.lastState == S_PLAY_TRIPFBALL2_AIR)
		and (mo.state ~= S_PLAY_TRIPFBALL2 and mo.state ~= S_PLAY_TRIPFBALL2_AIR)
			mo.spritexoffset = 0
			mo.extravalue1 = 0
		end

	end
end

-- Pressing spin
local function TripSpin(p)
	if not trip.IsValid(p.mo) return end
	if p.mo.state == S_PLAY_TRIPFBALL1 or p.mo.state == S_PLAY_TRIPFBALL2 then return true end
	if p.TRP.spikemode
		p.TRP.superreturntimer = $ or 5
		p.mo.state = S_PLAY_JUMP
		p.pflags = ($|PF_SPINNING|PF_JUMPED) & ~(PF_STARTJUMP)
			
		-- these and play sound
		S_StartSound(p.mo, sfx_s23d)

		trip.RollReturn(p)
		p.mo.trip_ceilingstick = nil
		p.mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
		p.mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
		return true
	end

	if p.powers[pw_super]
		trip.SuperSpinThinker(p)
		return
	end

	p.pflags = $ & ~PF_CANCARRY

	if p.TRP.spinHold return end
	if p.mo.state == S_PLAY_TRSPIKE and (not p.TRP.bounced) and (not (p.TRP.bounceLock)) and (not P_IsObjectInGoop(p.mo))
		p.TRP.bounceLock = true
		p.TRP.bounceLockPanic = trip.BOUNCELOCKPANIC
		p.TRP.squashpanic = trip.BOUNCELOCKPANIC
		S_StartSound(p.mo, sfx_kc5b)
	end
	if p.climbing then p.pflags = $ & ~PF_THOKKED end
	trip.WallReset(p)
end

local function NightsThink(p)
	if (not p.mo) or (not p.mo.valid) return end
	if p.mo.skin == "trip"
		trip.IdleCheck(p)
	end
end

-- Reset some basic stuff when needed
local function SoftReset(p)
	if p.valid and p == consoleplayer 
		trip.DoIO(p)
		if CBW_Battle and CBW_Battle.BattleGametype() and (not trip.ALLOWSMASHBRAWL)
			COM_BufInsertText(p, "smashbrawl mute")
		end
	end
	if (maptol & TOL_NIGHTS) 
		p.TRP = nil 
	elseif skins[p.skin].name == "trip"
		p.charflags = $ & ~SF_SUPER
	end
	if not trip.IsValid(p.mo) return end
	p.charflags = $ & ~SF_SUPER
	trip.ReturnFromSuper(p)
	p.TRP = nil
	if p.mo and p.mo.valid
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
	end
end

local function DeathWeirdness(mo)
	if not trip.IsValid(mo) return end
	local p = mo.player
	mo.spritexscale = FRACUNIT
	mo.spriteyscale = FRACUNIT
	if p.climbing 
		p.climbing = 0
		mo.state = S_PLAY_DEAD
	end
	trip.ReturnFromSuper(p)
	p.TRP = nil
end

-- Damaging enemies while climbing
local function ClimbDamager(p, mo)
	if not trip.IsValid(p.mo) return end
	if not mo or not mo.valid return end
	
	if p.mo.state == S_PLAY_CLING 
	or p.mo.state == S_PLAY_CLIMB
	or p.mo.state == S_PLAY_TSPIKEROLL 
		return true
	end

	-- :)
	if p.mo.state == S_PLAY_PAIN 
	and p.TRP.uhOh
		P_DamageMobj(mo, p.mo, p.mo, 3)
		return
	end
end

addHook("ShieldSpecial", function(p)
	if not trip.IsValid(p.mo) return end
	p.mo.cusval = p.powers[pw_shield]
	if p.TRP.jumpHold
		p.TRP.bitchassrevupbullshit = true -- [ frustrated bad coder noises ]
	end
end)

-- Something something pirate joke
addHook("PreThinkFrame", TPreThink)
addHook("PostThinkFrame", TPostThink)
addHook("PlayerThink", TripMain)
addHook("PlayerThink", NightsThink)
addHook("AbilitySpecial", TripJump)
addHook("SpinSpecial", TripSpin)
addHook("JumpSpecial", TripSpikes)
addHook("MobjDamage", TripSpikeBoost)
addHook("MobjDamage", TripDamageReset, MT_PLAYER)
addHook("PlayerSpawn", SoftReset)
addHook("PlayerCanDamage", ClimbDamager)
addHook("MobjDeath", DeathWeirdness, MT_PLAYER)