
	-- Freeslotting --

freeslot("MT_TRIPFLAME", "MT_TRIPBALLS", "MT_FAKEROCK",

"SPR_TRFL", "SPR_TRFB", "SPR_THEL", "SPR_TRSR",

"S_PLAY_TRSPIKE", "S_PLAY_TRIPTRIP", "S_PLAY_LIGHTBALL", "S_PLAY_TFLAP", 
"S_PLAY_TRIPFBALL1", "S_PLAY_TRIPFBALL2", "S_PLAY_TRIPFBALL3",
"S_PLAY_TRIPFBALL1_AIR", "S_PLAY_TRIPFBALL2_AIR", "S_PLAY_TWAIT1",
"S_PLAY_TWAIT2", "S_PLAY_TNROLL1", "S_PLAY_TNROLL2", "S_PLAY_TSPIKEROLL",
"S_TRIPFLAME", "S_TBBOUNCE", "S_TBFADE", "S_TTORCH", "S_FAKEROCK",

"SFX_TCURL", "SFX_TOOPS", "SFX_TFPLA", "SFX_TTAKO", "SFX_TCHEK", "SFX_TMARI",
"SFX_TFLAP", "SFX_TFIREA", "SFX_TBREA", "SFX_TRPHEW", "SFX_STJMP",
"SFX_TRFTST", "SFX_TRFTLO", "SFX_TRIDSP",

"SKINCOLOR_SUPER_TRIP_1", "SKINCOLOR_SUPER_TRIP_2", "SKINCOLOR_SUPER_TRIP_3",
"SKINCOLOR_SUPER_TRIP_4", "SKINCOLOR_SUPER_TRIP_5", "SKINCOLOR_TERRA_TRIP_1", 
"SKINCOLOR_TERRA_TRIP_2", "SKINCOLOR_TERRA_TRIP_3", "SKINCOLOR_TERRA_TRIP_4",
"SKINCOLOR_TERRA_TRIP_5")

	-- Skincolors --

-- Super / Dragon Trip
skincolors[SKINCOLOR_SUPER_TRIP_1] = {
    name = "Super TRIP 1",
    ramp = {0,72,72,72,72,65,65,66,66,66,68,68,68,63,63,63
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_TRIP_2] = {
    name = "Super TRIP 2",
    ramp = {0,81,81,72,72,72,65,65,65,65,67,67,67,63,63,63
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_TRIP_3] = {
    name = "Super TRIP 3",
    ramp = {0,81,81,72,72,72,65,64,64,64,67,67,67,61,61,61
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_TRIP_4] = {
    name = "Super TRIP 4",
    ramp = {0,80,80,82,82,82,64,72,72,72,65,65,65,69,69,69
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_TRIP_5] = {
    name = "Super TRIP 5",
    ramp = {0,0,0,81,81,81,82,83,83,83,64,64,64,67,67,67
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

-- Terra Trip
skincolors[SKINCOLOR_TERRA_TRIP_1] = {
    name = "Terra TRIP 1",
    ramp = {72,64,65,65,66,66,55,58,58,58,43,45,45,186,187,187
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_TERRA_TRIP_2] = {
    name = "Terra TRIP 2",
    ramp = {64,65,66,66,55,55,58,40,40,40,45,46,46,187,187,187
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_TERRA_TRIP_3] = {
    name = "Terra TRIP 3",
    ramp = {65,66,55,55,58,58,40,42,42,42,46,47,47,169,254,254
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_TERRA_TRIP_4] = {
    name = "Terra TRIP 4",
    ramp = {66,56,58,58,41,41,42,44,44,44,47,47,47,254,31,31
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_TERRA_TRIP_5] = {
    name = "Terra TRIP 5",
    ramp = {56,58,41,41,42,42,44,46,46,46,47,47,47,31,31,31
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

	-- Mobjs --

mobjinfo[MT_TRIPFLAME] = { -- Super Trip flame jet
	spawnstate = S_TRIPFLAME,
	radius = 20*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_MISSILE|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_TRIPBALLS] = { -- Battle mode trip fireballs. I refuse to change their mobj name.
	spawnstate = S_TBBOUNCE,
	radius = 15*FRACUNIT,
	height = 30*FRACUNIT,
	speed = 9*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_GRENADEBOUNCE
}

mobjinfo[MT_FAKEROCK] = { -- Battle mode trip fireballs. I refuse to change their mobj name.
	spawnstate = S_FAKEROCK,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP
}

	-- States --

states[S_PLAY_TRSPIKE] = { -- Spiked jump state
	sprite = SPR_PLAY,
	frame = SPR2_CLMB,
	tics = 1,
	nextstate = S_PLAY_TRSPIKE,
}

states[S_PLAY_TSPIKEROLL] = { -- Ceiling roll state
	sprite = SPR_PLAY,
	frame = SPR2_CLMB,
	tics = -1,
	nextstate = S_PLAY_TSPIKEROLL,
}

states[S_PLAY_TRIPTRIP] = { -- Faceplanted!
	sprite = SPR_PLAY,
	frame = SPR2_CNT1|FF_ANIMATE,
	var1 = 1,
	var2 = 10,
	tics = -1,
	nextstate = S_PLAY_TRIPTRIP
}

states[S_PLAY_TRIPFBALL1] = { -- Trip is spewing out a fireball, phase 1
	sprite = SPR_PLAY,
	frame = SPR2_TAL2,
	tics = -1,
	nextstate = S_PLAY_TRIPFBALL1
}

states[S_PLAY_TRIPFBALL2] = { -- Trip is spewing out a fireball, phase 2
	sprite = SPR_PLAY,
	frame = SPR2_TAL3,
	tics = -1,
	nextstate = S_PLAY_TRIPFBALL2
}

states[S_PLAY_TRIPFBALL1_AIR] = { -- Trip is spewing out a fireball, phase 1 aerial
	sprite = SPR_PLAY,
	frame = SPR2_TAL5,
	tics = -1,
	nextstate = S_PLAY_TRIPFBALL1_AIR
}

states[S_PLAY_TRIPFBALL2_AIR] = { -- Trip is spewing out a fireball, phase 2 aerial
	sprite = SPR_PLAY,
	frame = SPR2_TAL6,
	tics = -1,
	nextstate = S_PLAY_TRIPFBALL2_AIR
}

states[S_PLAY_TRIPFBALL3] = { -- Trip is spewing out a fireball, phase 3
	sprite = SPR_PLAY,
	frame = SPR2_TAL4,
	tics = 10,
	nextstate = S_PLAY_STND
}

states[S_PLAY_TNROLL1] = { -- Trip's special jump ball
	sprite = SPR_PLAY,
	frame = SPR2_JUMP,
	tics = 2,
	nextstate = S_PLAY_TNROLL1
}

states[S_PLAY_TNROLL2] = { -- Trip's special roll ball
	sprite = SPR_PLAY,
	frame = SPR2_JUMP,
	tics = 2,
	nextstate = S_PLAY_TNROLL2
}

states[S_PLAY_LIGHTBALL] = { -- Super Trip's light ball rolling state
	sprite = SPR_PLAY,
	frame = SPR2_ROLL|A|FF_ANIMATE|FF_ADD|FF_FULLBRIGHT,
	var1 = 3,
	var2 = 1,
	tics = 4,
	nextstate = S_PLAY_LIGHTBALL,
}

states[S_FAKEROCK] = { -- Fake rocks for our rock effects
	sprite = SPR_ROIA,
	frame = A|FF_ANIMATE,
	var1 = 4,
	var2 = 2,
	tics = -1,
	nextstate = S_FAKEROCK,
}

states[S_TRIPFLAME] = { -- Default state for Super Trip's flame jets
	sprite = SPR_TRFL,
	frame = A|FF_ANIMATE|FF_ADD|FF_FULLBRIGHT,
	var1 = 5,
	var2 = 3,
	tics = 19,
	nextstate = S_NULL,
}

states[S_TBBOUNCE] = { -- Battle mode fireball bouncing
	sprite = SPR_TRFB,
	frame = A|FF_ADD,
	tics = TICRATE*2,
	nextstate = S_NULL,
}

states[S_TTORCH] = { -- Torch sprites for our lingering flames
	sprite = SPR_FLAM,
	frame = FF_ANIMATE|FF_ADD|FF_TRANS30,
	var1 = 3,
	var2 = 3,
	tics = TICRATE*3,
	nextstate = S_NULL,
}

states[S_PLAY_TWAIT1] = { -- Initial waiting sprites
	sprite = SPR_PLAY,
	frame = SPR2_WAIT|FF_ANIMATE,
	var1 = 25,
	var2 = 4,
	tics = 100,
	nextstate = S_PLAY_TWAIT2,
}

states[S_PLAY_TWAIT2] = { -- Initial waiting sprites
	sprite = SPR_PLAY,
	frame = SPR2_TAL7|FF_ANIMATE,
	tics = -1,
	var1 = 9,
	var2 = 6,
	nextstate = S_PLAY_TWAIT2,
}

	-- SFX captioning --

sfxinfo[sfx_tcurl].caption  = "Spikes!"
sfxinfo[sfx_toops].caption  = "Whoa!"
sfxinfo[sfx_tfpla].caption  = "Faceplanting"
sfxinfo[sfx_ttako].caption  = "Takeoff"
sfxinfo[sfx_tchek].caption  = "Thank you!"
sfxinfo[sfx_tmari].caption  = "Spewing flames"
sfxinfo[sfx_tflap].caption  = "Flapping wings"
sfxinfo[sfx_tbrea].caption  = "Breathing in"
sfxinfo[sfx_tfirea].caption  = "Flame breath ready!"
sfxinfo[sfx_trphew].caption  = "Phew..."
sfxinfo[sfx_trftst].caption  = "Flamethrower"
sfxinfo[sfx_trftlo].caption  = "Flamethrower"
sfxinfo[sfx_tridsp].caption  = "Skewering foe"
sfxinfo[sfx_stjmp].caption  = "Jump"
sfxinfo[sfx_s23b].caption   = "Landing"
sfxinfo[sfx_s23d].caption   = "Attaching to wall"
sfxinfo[sfx_kc43].caption   = "Ow..."
sfxinfo[sfx_kc5b].caption   = "Downwards boost"
sfxinfo[sfx_kc31].caption   = "Spreading dust"
sfxinfo[sfx_kc55].caption   = "Helmet movement"
sfxinfo[sfx_cdfm32].caption = "Earthquake"
sfxinfo[sfx_cdfm17].caption = "Fidget"